set wshshell=createobject("WScript.Shell")
set fs=createobject("Scripting.FileSystemObject")

REM DIM Variables
DIM DBUSER,DBDATA,PASSWD,DBKEVL,LOG,OSQL

wshshell.popup "Update von synPARTSkevl Datenbanken",3,"Datenupdate",vbSystemModal 

OSQL=checkosql()

Do
	Auswahl = InputBox("Sind Sie im Windows als Datenbankadministrator angemeldet ?" & vbcrlf & vbcrlf & " (J/N) ")
		If Auswahl = vbEmpty Then wscript.quit	
	  If IsEmpty(Auswahl) Then Auswahl ="Z"
	Select case UCase(Auswahl)
		case "J"
			DBUSER = "-E" 
		case "N" 
			USER = Inputbox("Name des SQL-Datenbankadminstrators:")
			PASSWD = Inputbox("Passwort des Datenbankadministrators:")
			DBUSER = "-U " & USER & " -P " & PASSWD  
		case else
			wshshell.popup "Ungltige Auswahl",2,"ERROR",vbSystemModal
	end Select
loop until Not IsEmpty(DBUSER)

DBDATA = InputBox("Name MSSQL-Server (leer = localhost):" & vbcrlf & vbcrlf & " ( z.B. KEVLDBSRV )")
If DBDATA = vbEmpty Then wscript.quit
If IsEmpty(DBDATA) Then DBDATA = "localhost"
	
do
	DBKEVL = InputBox("Name der synPARTSkevl DB:" & vbcrlf & vbcrlf & " ( z.B. KEVLDB )" )
	If DBKEVL = vbEmpty Then wscript.quit	
	If IsEmpty(DBKEVL) Then 
		wshshell.popup "Ungltige Auswahl",2,"ERROR",vbSystemModal
		DBOK="FALSE"
  Else
  	DBOK="TRUE"
  End If 	 
loop until DBOK="TRUE"

Set objExplorer = CreateObject("InternetExplorer.Application") 
objExplorer.Navigate "about:blank" 
objExplorer.Toolbar = 0 
objExplorer.StatusBar = 0 
objExplorer.Width = 600 
objExplorer.Height = 400 
objExplorer.Left = 300 
objExplorer.Top = 150 
objExplorer.Visible = 1
Do While (objExplorer.Busy) 
Loop
Set objDocument = objExplorer.Document 
objDocument.Open
objDocument.Writeln "<html><head><title>synPARTSkevl Update</title></head>" 
objDocument.Writeln "<body><bgcolor='white'>" 

runosql("connect.sql")
runosql("dbupdate.sql")




wshshell.popup "Datenupdate erfolgreich beendet"

Function checkosql()
Const HKEY_LOCAL_MACHINE = &H80000002
strComputername = "."
Set oReg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputername & "\root\default:StdRegProv")

strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion"
strValue = "ProgramFilesDir"
oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValue, str_prog
 
If fs.fileexists(str_prog & "\Microsoft SQL Server\120\Tools\Binn\osql.exe") Then
	wshshell.popup str_prog & "\Microsoft SQL Server\120\Tools\Binn\osql.exe found",2,,vbSystemModal 
  checkosql= str_prog & "\Microsoft SQL Server\120\Tools\Binn\osql.exe"
Else
  If fs.fileexists(str_prog & "\Microsoft SQL Server\130\Tools\Binn\osql.exe") Then	
		wshshell.popup str_prog & "\Microsoft SQL Server\130\Tools\Binn\osql.exe found",2,,vbSystemModal
	  checkosql=str_prog & "\Microsoft SQL Server\130\Tools\Binn\osql.exe"
  Else
  	If fs.fileexists(str_prog & "\Microsoft SQL Server\140\Tools\Binn\osql.exe") Then	
			wshshell.popup str_prog & "\Microsoft SQL Server\140\Tools\Binn\osql.exe found",2,,vbSystemModal
	  	checkosql=str_prog & "\Microsoft SQL Server\140\Tools\Binn\osql.exe"
  	Else
  		If fs.fileexists(str_prog & "\Microsoft SQL Server\150\Tools\Binn\osql.exe") Then	
			wshshell.popup str_prog & "\Microsoft SQL Server\150\Tools\Binn\osql.exe found",2,,vbSystemModal
	  		checkosql=str_prog & "\Microsoft SQL Server\150\Tools\Binn\osql.exe"
  		Else
  			wshshell.popup "Program osql not found"
  			checkosql = Inputbox("Bitte geben Sie das Verzeichnis an, in dem sich die osql.exe befindet")
  			If fs.fileexists(checkosql &"osql.exe") Then
				wshshell.popup checkosql &" found",2,,vbSystemModal 
			Else
  				wscript.quit
  			End If
  		End If
  	End If
  End If
End If
End Function


Function runosql(SCRIPT)
	LOG = Replace(SCRIPT,".sql",".log")
	objDocument.Writeln "<p><b> Start " & SCRIPT & "</b> </p>"
  rc=wshshell.run("""" & OSQL & """" & " -n -b -o  " & LOG & " " & DBUSER & " -S " & DBDATA _
  & " -d " & DBKEVL & " -i " & SCRIPT,0,true) 
  If Not rc=0 Then 
  	objDocument.Writeln "<p><b> Error in Script " & SCRIPT & "</b> </p>"
  	objDocument.Writeln "<p><b> For details see in " & LOG & " </b> </p>" 	
  	objDocument.Writeln "<p><b> dbupdate finished with error </b> </p>" 	
  	wshshell.popup "Error in Script: " & SCRIPT,,"ERROR",vbSystemModal
  	wscript.quit
  Else
  	objDocument.Writeln "<p><b> Script " & SCRIPT & " ohne Fehler beendet</b> </p>"
 	  wshshell.popup "Script " & SCRIPT & " ohne Fehler beendet",2,SCRIPT,vbSystemModal
  End If
End Function	

