set objShell = WScript.CreateObject ("WScript.Shell")
Set objFS = CreateObject("Scripting.FileSystemObject")
Set args = WScript.Arguments		'bergabe der aktuellen ke.ini als Parameter

Const ForReading = 1
Const ForWriting = 2

ShortName = WScript.scriptname
FullName = WScript.scriptfullname
ScriptPfad = Left(FullName,Len(FullName)-Len(ShortName))
objShell.currentdirectory = ScriptPfad

Dim Ini, RC, KevlFolder, Release
Dim Log : Log = ScriptPfad & "update.log"
Dim Version: Version = ScriptPfad & "version.txt"
Dim FileList: FileList = ScriptPfad & "filelist.txt"
Set objLog = objFS.CreateTextFile(Log)

objshell.popup "Update von synPARTSkevl",3,"Update SynPARTSKevl" 
objLog.WriteLine Date & " " & Time

Rem RC=CHECK_PARA
Rem If RC <> "True" Then PRINT_ERROR

Rem Set objIni = objFS.GetFile(Ini)
Rem KevlFolder = objIni.ParentFolder & "\"


KevlFolder = BrowseForFolder( _
        "Select the SynPARTSkevl-Programfolder",&H0,"")
If KevlFolder = "-5" Then 
    WScript.Echo "Not possible to select files in root folder"
    Wscript.Quit
Else
    If KevlFolder = "-1" Then 
        WScript.Echo "No object selected; Cancel clicked"
        Wscript.Quit
    End If
End If 

KevlFolder = KevlFolder & "\"
RC=CHECK_FILE(KevlFolder & "synPARTSkevl.exe")
If RC <> "True" Then PRINT_ERROR
RC=CHECK_FILE(Version)
If RC <> "True" Then PRINT_ERROR
Set objFSVersion = objFS.OpenTextFile(Version, ForReading)
Do Until objFSVersion.AtEndOfStream		'Einlesen der Datei 
		strline = objFSVersion.ReadLine
	If InStr(strline,"Version") > 0 Then
		VersionStr = Split(strline,":=")
		Release = Trim(VersionStr(1))
		If Release = "" Then 
			RC = "Error: Version not found"
			PRINT_ERROR
		End If
	End If
Loop
objFSVersion.Close

RC=CHECK_FILE(KevlFolder & "synPARTSkevl." & Release)
If RC = "True" Then
	RC = "Error: File " & KevlFolder & "synPARTSkevl." & Release & " existiert. Update bereits durchgefhrt? "
	PRINT_ERROR
End If

RC=CHECK_FILE(FileList)
If RC <> "True" Then PRINT_ERROR

CopyFile

RC = "Update successful !"
PRINT_ERROR
objLog.close
wscript.quit

Sub CopyFile
On Error Resume Next
'alle Dateien aus Filelist kopieren
Set objFSFileList = objFS.OpenTextFile(Filelist, ForReading)
Do Until objFSFileList.AtEndOfStream		'Einlesen der Datei 
		strline = objFSFileList.ReadLine
		RC = objFS.CopyFile(strline,KevlFolder) 		'Copy File
    RC = CHECK_ERROR
    If RC <> "True" Then 
	     RC = "Error: Copy " & strline
	     PRINT_ERROR
    End If
Loop
objFSFileList.Close

'Sicherung der neu bertragenen Dateien anlegen
RC = objFS.CopyFile(KevlFolder & "synPARTSkevl.exe",KevlFolder & "synPARTSkevl." & Release) 		'Copy File
    RC = CHECK_ERROR
    If RC <> "True" Then 
	     RC = "Error: Backup synPARTSkevl.exe" 
	     PRINT_ERROR
    End If
RC = objFS.CopyFile(KevlFolder & "version.txt",KevlFolder & "version." & Release) 		'Copy File
    RC = CHECK_ERROR
    If RC <> "True" Then 
	     RC = "Error: Backup version.txt" 
	     PRINT_ERROR
    End If
    

End Sub

Function CHECK_ERROR()
	If err.number <> 0 Then
		  CHECK_ERROR = "Error"
 	 		err.clear
 	 	Else
 	 		CHECK_ERROR = "True"
	End If
End Function

Function CHECK_PARA()
If args.count = 0 Then
	CHECK_PARA = "Keine Ini-Datei als Parameter bergeben!"
Else
	Ini = args(0)
	If objFS.FileExists(Ini) Then
		CHECK_PARA = "True"
	Else
		CHECK_PARA = "File " & Ini & " existiert nicht"
	End If 
End If
End Function

Function CHECK_FILE(Name)
	If objFS.FileExists(Name) Then
		CHECK_FILE = "True"
	Else
		CHECK_FILE = "Error: File " & Name & " existiert nicht"
	End If 
End Function

Function PRINT_ERROR
  objLog.WriteLine RC
	MsgBox RC
	objLog.close
  wscript.quit
End Function

Function BrowseForFolder(title, flag, dir)
' Using the shell's BrowseForFolder method to
' return the full path to the selected object
' title = Text shown in the dialog box
' flag = One of the values for controlling the 
'        BrowseForFolder behavior
' dir = Preselected directory (can be "")
' Flags for the options parameter
Const BIF_returnonlyfsdirs   = &H0001
Const BIF_dontgobelowdomain  = &H0002
Const BIF_statustext         = &H0004
Const BIF_returnfsancestors  = &H0008
Const BIF_editbox            = &H0010
Const BIF_validate           = &H0020
Const BIF_browseforcomputer  = &H1000
Const BIF_browseforprinter   = &H2000
Const BIF_browseincludefiles = &H4000

    On Error Resume Next

    Dim oShell, oItem, tmp
 
    ' Create WshShell object.
    Set oShell = WScript.CreateObject("Shell.Application")

    ' Invoke Browse For Folder dialog box.
    Set oItem = oShell.BrowseForFolder(&H0, title, flag, dir)
    If Err.Number <> 0 Then
        If Err.Number = 5 Then
            BrowseForFolder= "-5"
            Err.Clear
            Set oShell = Nothing
            Set oItem = Nothing
            Exit Function
        End If
    End If

    ' Now we try to retrieve the full path.
    BrowseForFolder = oItem.ParentFolder.ParseName(oItem.Title).Path

    ' Handling: Cancel button and selecting a drive
    If Err<> 0 Then
    		'MsgBox(Err.Number)
        If Err.Number = 424 Then           ' Handle Cancel button.
            BrowseForFolder = "-1"
        Else
            Err.Clear
            ' Handle situation in which user selects a drive.
            ' Extract drive letter from the title--first search
            ' for a colon (:).
            tmp = InStr(1, oItem.Title, ":")
            If tmp > 0 Then           ' A : is found; use two 
                                      ' characters and add \.
                BrowseForFolder = _   
                    Mid(oItem.Title, (tmp - 1), 2) & "\"
            End If
        End If
    End If

    Set oShell = Nothing
    Set oItem = Nothing
    On Error GoTo 0
End Function
